-- TOGGLE DASH by Clone Fighter

local ToggleDashSkin = "sonic" -- Change this to the skin you want to use the ability.
local ToggleDashMaxCharge = 3*TICRATE/2 -- The time it takes to be able to trigger a Toggle Dash.
local ToggleDashMult = 8*FRACUNIT/5 -- The speed multiplier when in a Toggle Dash.
local ToggleDashMercy = 7 -- How many 'mercy tics' the game will give you to activate a Toggle Dash.
-- Because usually, when you release your "forward" direction, the game will put you out of the running state :P

-- Below this comment is the ability's code.
-- If you're just re-using this, there's no need to touch anything here.
-- However, feel free to make edits if you know what you're doing.

local function AngleCheck(ang1, ang2, delta)
	return abs(ang1-ang2) <= delta
end

addHook("PlayerThink", function(player)
    if not player.mo or not player.mo.valid or player.mo.skin != ToggleDashSkin then return end
	
    player.toggleDashCharge = $ or 0
	player.toggleDashThreshold = $ or -1
	player.toggleDashActive = $ or 0
	player.normalspeedArchive = $ or player.normalspeed
	
	-- AUTOBRAKE HACK: If you have Autobrake, the fact that it is is stored, then you have it temporarily REMOVED so you can trigger the ability
	player.reapplyAutobrake = $ or false
	if player.toggleDashActive == 2 and player.reapplyAutobrake then
		player.pflags = $|PF_AUTOBRAKE
		player.reapplyAutobrake = false
	end

	-- Build momentum...
    if player.speed > player.runspeed then
        player.toggleDashCharge = min(ToggleDashMaxCharge + 1, $+1)
		if player.toggleDashActive != 1 and player.toggleDashCharge >= ToggleDashMaxCharge then player.toggleDashThreshold = ToggleDashMercy end
		
		if player.toggleDashActive == 2 and player.mo.state == S_PLAY_RUN then player.mo.state = S_PLAY_DASH end
	else
		player.toggleDashThreshold = max($-1, 0)
    end
	
	if player.toggleDashActive != 1 and player.speed < player.runspeed
	or player.toggleDashActive == 1 and player.toggleDashThreshold == 0
	or player.mo.state == S_PLAY_SKID or player.mo.state == S_PLAY_PAIN or player.deadtimer then
        if S_SoundPlaying(player.mo, sfx_monton) then
			S_StopSoundByID(player.mo, sfx_monton)
		end
		if player.toggleDashCharge >= ToggleDashMaxCharge - TICRATE/2 then
			S_StartSound(player.mo, sfx_kc65)
		end
        player.toggleDashCharge = 0
		player.toggleDashThreshold = -1
		player.toggleDashActive = 0
		player.normalspeed = player.normalspeedArchive
		player.charflags = $ & ~SF_RUNONWATER
        player.mo.colorized = false
		if player.mo.state == S_PLAY_DASH then player.mo.state = S_PLAY_WALK end
    end
	
    if player.toggleDashCharge >= ToggleDashMaxCharge - TICRATE/2 then
        if player.toggleDashCharge >= ToggleDashMaxCharge then
			if player.toggleDashCharge == ToggleDashMaxCharge then
				player.mo.colorized = false
			end
			local ghost = P_SpawnGhostMobj(player.mo)
			ghost.fuse = 3
			ghost.colorized = true
			ghost.frame = $|FF_ADD
			
			if player.toggleDashActive != 2 and player.pflags & PF_AUTOBRAKE then
				player.reapplyAutobrake = true
				player.pflags = $ & ~PF_AUTOBRAKE
			end
		else
            if player.toggleDashCharge == ToggleDashMaxCharge - TICRATE/2 then
                S_StartSound(player.mo, sfx_monton)
            end
            local t = player.toggleDashCharge - TICRATE
            player.mo.colorized = (ease.inquad(t*FRACUNIT/(TICRATE/2), 0, 36) % 2) == 1
        end
    end
	
	-- FOCUS YOUR ENERGY... (release your accelerator!)
	if FixedHypot(player.cmd.forwardmove*FRACUNIT, player.cmd.sidemove*FRACUNIT) < 15*FRACUNIT then
		if player.toggleDashCharge >= ToggleDashMaxCharge and player.toggleDashActive == 0 then
			player.toggleDashActive = 1
		end
	
	-- ...and DASH!
	elseif AngleCheck(R_PointToAngle2(0,0, player.cmd.sidemove*FRACUNIT, player.cmd.forwardmove*FRACUNIT) + player.mo.angle - ANGLE_90,
			R_PointToAngle2(0,0, player.mo.momx, player.mo.momy), ANGLE_45)
	and player.toggleDashActive == 1 then
		player.toggleDashActive = 2
		player.toggleDashThreshold = -1
		player.normalspeedArchive = player.normalspeed
		player.charflags = $|SF_RUNONWATER
		player.normalspeed = FixedMul($, ToggleDashMult)
		
		P_Thrust(player.mo, R_PointToAngle2(0,0, player.cmd.sidemove*FRACUNIT, player.cmd.forwardmove*FRACUNIT) + player.mo.angle - ANGLE_90,
				FixedMul(player.runspeed, player.mo.scale))
		
		S_StartSound(player.mo, sfx_cdfm40)
		P_StartQuake(FRACUNIT*10, TICRATE/2, {player.mo.x,player.mo.y,player.mo.z}, 1536*FRACUNIT)
		
		for i = 0, 15, 1 do
			local angle = R_PointToAngle2(0,0, player.mo.momx, player.mo.momy) + ANGLE_90
			local sparkle = P_SpawnMobjFromMobj(player.mo, 0,0,player.mo.height/2, MT_NIGHTSPARKLE)
			sparkle.tics = TICRATE/3
			P_InstaThrust(sparkle, angle, FixedMul(12*FRACUNIT, cos(i*ANGLE_22h)))
			P_SetObjectMomZ(sparkle, FixedMul(12*FRACUNIT, sin(i*ANGLE_22h)))
			if i%4 == 0 then P_DoSpinDashDust(player) end
		end
	end
end)
